> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Get device count history

GET https://example.itential.io/device-counts

Returns device count history.

Reference: https://docs.itential.com/itential-platform/6/api-reference/device-counts/get-device-counts

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Query parameters

- `skip` (integer, optional, default: 0) — skip
- `limit` (integer, optional, default: 25) — limit
- `order` (enum, optional, default: newest) — order
  - Allowed values: `newest`, `oldest`
- `serverId` (string, optional) — The server ID where the device counts came from
- `before` (integer, optional) — The timestamp in milliseconds used as an upper range. Should be higher than the after value.
- `after` (integer, optional) — The timestamp in milliseconds used as a lower range. Should be lower than the after value.

## Response

### 200

The device counts matching the specified query.

- `results` (object, optional) — This is the schema for an IAP device count stored in Mongo
  - `timestamp` (string, required) — An ISODate representing when the device count was taken
  - `serverId` (string, required) — The serverId where the device count was taken
  - `counts` (map from string to integer, required) — The key/value pair between an adapter name and the number of devices
- `total` (integer, optional) — The total number of documents

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Response**

```json
{
  "results": {
    "timestamp": "2023-02-14T20:06:50.569Z",
    "serverId": "string",
    "counts": {}
  },
  "total": 1
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/device-counts"

response = requests.get(url)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/device-counts';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/device-counts"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/device-counts")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://example.itential.io/device-counts")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://example.itential.io/device-counts');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/device-counts");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/device-counts")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```